function TrigunTick()
{
	cancel($TrigunTick);
	$TrigunTick = schedule(250,0,TrigunTick);
}
package Trigun_InputEvent_OnVehicleTouch
{
	function TrigunTick()
	{
		parent::TrigunTick();
		if(IsObject(MissionCleanup))
		{
			for(%i = 0; %i < MissionCleanup.getCount(); %i++)
			{
				%obj = MissionCleanup.getObject(%i);
				if(%obj.getClassname() $= "WheeledVehicle" || %obj.getClassname() $= "FlyingWheeledVehicle" || %obj.getClassname() $= "FlyingVehicle" || %obj.getClassname() $= "HoverVehicle")
				{
					%x = getWord(%obj.getWorldBox(),0) - getWord(%obj.getWorldBox(),3);
					if(%x < 0)
						%x = %x * -1;
					%y = getWord(%obj.getWorldBox(),1) - getWord(%obj.getWorldBox(),4);
					if(%y < 0)
						%y = %y * -1;
					%z = getWord(%obj.getWorldBox(),2) - getWord(%obj.getWorldBox(),5);
					if(%z < 0)
						%z = %z * -1;
					InitContainerBoxSearch(%obj.getPosition(),%x SPC %y SPC %z,$TypeMasks::FXBrickObjectType);
					while(isObject(%checkObj = containerSearchNext()))
					{
						if(%checkObj.isPlanted())
						{
							if(%obj.spawnbrick.getGroup().client.minigame $= %checkobj.getGroup().client.minigame)
							{
								if(%checkObj.isColliding())
									%checkObj.onVehicleTouch(%obj);
								%checkObj.onVehicleEnter(%obj);
								%checkObj.isTouching[%obj] = 1;
								%checkObj.schedule(249,ResetVehicleTouch,%obj);
								%checkObj.schedule(251,PingVehicleCollision,%obj);
							}
						}
					}
				}
			}
		}
	}
	function FXDTSBrick::PingVehicleCollision(%this,%vehicle)
	{
		if(isObject(%vehicle))
		{
			if(!%this.isTouching[%vehicle])
			{
				if(%this.isColliding())
					%this.onVehicleStopTouch(%vehicle);
				%this.onVehicleLeave(%vehicle);
			}
		}	
	}
	function FXDTSBrick::ResetVehicleTouch(%this,%vehicle)
	{
		%this.isTouching[%vehicle] = 0;
	}
};
ActivatePackage(Trigun_InputEvent_OnVehicleTouch);
schedule(5000,0,TrigunTick);

registerInputEvent(fxDTSBrick, "onVehicleTouch", "Self fxDTSBrick\tVehicle Vehicle\tDriver Player\tDrivingClient GameConnection\tOwner GameConnection\tMiniGame MiniGame",1);
function fxDTSBrick::onVehicleTouch(%this, %vehicle)
{
	$inputTarget_self = %this;
	$inputTarget_drivingclient = %vehicle.getControllingObject().client;
	$inputTarget_driver = %vehicle.getControllingObject();
	$inputTarget_owner = %vehicle.spawnBrick.getGroup().client;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	$inputTarget_vehicle = %vehicle;
	if(!%vehicle.getControllingObject().client)
		%this.processInputEvent("OnVehicleTouch",%vehicle.spawnbrick.getGroup().client);
	else
		%this.processInputEvent("OnVehicleTouch",%vehicle.getControllingObject().client);
}
registerInputEvent(fxDTSBrick, "onVehicleEnter", "Self fxDTSBrick\tVehicle Vehicle\tDriver Player\tDrivingClient GameConnection\tOwner GameConnection\tMiniGame MiniGame",1);
function fxDTSBrick::onVehicleEnter(%this, %vehicle)
{
	$inputTarget_self = %this;
	$inputTarget_drivingclient = %vehicle.getControllingObject().client;
	$inputTarget_driver = %vehicle.getControllingObject();
	$inputTarget_owner = %vehicle.spawnBrick.getGroup().client;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	$inputTarget_vehicle = %vehicle;
	if(!%vehicle.getControllingObject().client)
		%this.processInputEvent("OnVehicleEnter",%vehicle.spawnbrick.getGroup().client);
	else
		%this.processInputEvent("OnVehicleEnter",%vehicle.getControllingObject().client);
}
registerInputEvent(fxDTSBrick, "onVehicleLeave", "Self fxDTSBrick\tVehicle Vehicle\tDriver Player\tDrivingClient GameConnection\tOwner GameConnection\tMiniGame MiniGame",1);
function fxDTSBrick::onVehicleLeave(%this, %vehicle)
{
	$inputTarget_self = %this;
	$inputTarget_drivingclient = %vehicle.getControllingObject().client;
	$inputTarget_driver = %vehicle.getControllingObject();
	$inputTarget_owner = %vehicle.spawnBrick.getGroup().client;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	$inputTarget_vehicle = %vehicle;
	if(!%vehicle.getControllingObject().client)
		%this.processInputEvent("OnVehicleLeave",%vehicle.spawnbrick.getGroup().client);
	else
		%this.processInputEvent("OnVehicleLeave",%vehicle.getControllingObject().client);
}
registerInputEvent(fxDTSBrick, "onVehicleStopTouch", "Self fxDTSBrick\tVehicle Vehicle\tDriver Player\tDrivingClient GameConnection\tOwner GameConnection\tMiniGame MiniGame",1);
function fxDTSBrick::onVehicleStopTouch(%this, %vehicle)
{
	$inputTarget_self = %this;
	$inputTarget_drivingclient = %vehicle.getControllingObject().client;
	$inputTarget_driver = %vehicle.getControllingObject();
	$inputTarget_owner = %vehicle.spawnBrick.getGroup().client;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	$inputTarget_vehicle = %vehicle;
	if(!%vehicle.getControllingObject().client)
		%this.processInputEvent("OnVehicleStopTouch",%vehicle.spawnbrick.getGroup().client);
	else
		%this.processInputEvent("OnVehicleStopTouch",%vehicle.getControllingObject().client);
}